import { HttpClient, HttpEvent, HttpHeaders, HttpParams, HttpResponse } from '@angular/common/http';
import { Inject, Injectable, Optional } from '@angular/core';
import { Observable } from 'rxjs';

import { Configuration } from '../configuration';
import { CustomHttpUrlEncodingCodec } from '../encoder';
import { Response200 } from '../model/response200';
import { BASE_PATH } from '../variables';

/**
 * Tankerkönig API
 * API for getting real time gas prices from https://creativecommons.tankerkoenig.de. Real time gas price data is available under open data/open source license even for commercial use. Currently only prices for Germany are available.
 *
 * OpenAPI spec version: 4.0.6
 * Contact: info@tankerkoenig.de
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */ /* tslint:disable:no-unused-variable member-ordering */

@Injectable()
export class TankerkoenigSearchService {
  protected basePath = 'https://creativecommons.tankerkoenig.de/api/v4';
  public defaultHeaders = new HttpHeaders();
  public configuration = new Configuration();

  constructor(protected httpClient: HttpClient, @Optional() @Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
    if (basePath) {
      this.basePath = basePath;
    }
    if (configuration) {
      this.configuration = configuration;
      this.basePath = basePath || configuration.basePath || this.basePath;
    }
  }

  /**
   *
   * Aktuelle Kraftstoffpreise an Tankstellen nach IDs
   * @param apikey Gültiger API-key / Valid API key.
   * @param ids Liste von Land, Tankstellen-IDs (komma-separiert) / List of country / station ids (comma separated).
   * @param lat Latitude. If latitude and longitude are given, dist to this coordinates is shown in the output
   * @param lng Longitude. If latitude and longitude are given, dist to this coordinates is shown in the output
   * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
   * @param reportProgress flag to report request and response progress.
   */
  public stationsIdsGet(apikey: string, ids: string, lat?: number, lng?: number, observe?: 'body', reportProgress?: boolean): Observable<Response200>;
  public stationsIdsGet(apikey: string, ids: string, lat?: number, lng?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Response200>>;
  public stationsIdsGet(apikey: string, ids: string, lat?: number, lng?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Response200>>;
  public stationsIdsGet(apikey: string, ids: string, lat?: number, lng?: number, observe: any = 'body', reportProgress: boolean = false): Observable<any> {
    if (apikey === null || apikey === undefined) {
      throw new Error('Required parameter apikey was null or undefined when calling stationsIdsGet.');
    }

    if (ids === null || ids === undefined) {
      throw new Error('Required parameter ids was null or undefined when calling stationsIdsGet.');
    }

    let queryParameters = new HttpParams({
      encoder: new CustomHttpUrlEncodingCodec(),
    });
    if (apikey !== undefined && apikey !== null) {
      queryParameters = queryParameters.set('apikey', <any>apikey);
    }
    if (ids !== undefined && ids !== null) {
      queryParameters = queryParameters.set('ids', <any>ids);
    }
    if (lat !== undefined && lat !== null) {
      queryParameters = queryParameters.set('lat', <any>lat);
    }
    if (lng !== undefined && lng !== null) {
      queryParameters = queryParameters.set('lng', <any>lng);
    }

    let headers = this.defaultHeaders;

    // to determine the Accept header
    let httpHeaderAccepts: string[] = ['application/json; charset=utf-8'];
    const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected != undefined) {
      headers = headers.set('Accept', httpHeaderAcceptSelected);
    }

    // to determine the Content-Type header

    return this.httpClient.request<Response200>('get', `${this.basePath}/stations/ids`, {
      params: queryParameters,
      withCredentials: this.configuration.withCredentials,
      headers: headers,
      observe: observe,
      reportProgress: reportProgress,
    });
  }

  /**
   *
   * Aktuelle Kraftstoffpreise an Tankstellen nach Postleitzahl
   * @param apikey Gültiger API-key / Valid API key.
   * @param postalcode Land:Postleitzahl / county:postalcode
   * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
   * @param reportProgress flag to report request and response progress.
   */
  public stationsPostalcodeGet(apikey: string, postalcode: string, observe?: 'body', reportProgress?: boolean): Observable<Response200>;
  public stationsPostalcodeGet(apikey: string, postalcode: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Response200>>;
  public stationsPostalcodeGet(apikey: string, postalcode: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Response200>>;
  public stationsPostalcodeGet(apikey: string, postalcode: string, observe: any = 'body', reportProgress: boolean = false): Observable<any> {
    if (apikey === null || apikey === undefined) {
      throw new Error('Required parameter apikey was null or undefined when calling stationsPostalcodeGet.');
    }

    if (postalcode === null || postalcode === undefined) {
      throw new Error('Required parameter postalcode was null or undefined when calling stationsPostalcodeGet.');
    }

    let queryParameters = new HttpParams({
      encoder: new CustomHttpUrlEncodingCodec(),
    });
    if (apikey !== undefined && apikey !== null) {
      queryParameters = queryParameters.set('apikey', <any>apikey);
    }
    if (postalcode !== undefined && postalcode !== null) {
      queryParameters = queryParameters.set('postalcode', <any>postalcode);
    }

    let headers = this.defaultHeaders;

    // to determine the Accept header
    let httpHeaderAccepts: string[] = ['application/json; charset=utf-8'];
    const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected != undefined) {
      headers = headers.set('Accept', httpHeaderAcceptSelected);
    }

    // to determine the Content-Type header

    return this.httpClient.request<Response200>('get', `${this.basePath}/stations/postalcode`, {
      params: queryParameters,
      withCredentials: this.configuration.withCredentials,
      headers: headers,
      observe: observe,
      reportProgress: reportProgress,
    });
  }

  /**
   *
   * Aktuelle Kraftstoffpreise an Tankstellen im Umkreis
   * @param apikey Gültiger API-key / Valid API key.
   * @param lat Latitude
   * @param lng Longitude
   * @param rad Radius in km (max 25)
   * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
   * @param reportProgress flag to report request and response progress.
   */
  public stationsSearchGet(apikey: string, lat: number, lng: number, rad?: number, observe?: 'body', reportProgress?: boolean): Observable<Response200>;
  public stationsSearchGet(apikey: string, lat: number, lng: number, rad?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Response200>>;
  public stationsSearchGet(apikey: string, lat: number, lng: number, rad?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Response200>>;
  public stationsSearchGet(apikey: string, lat: number, lng: number, rad?: number, observe: any = 'body', reportProgress: boolean = false): Observable<any> {
    if (apikey === null || apikey === undefined) {
      throw new Error('Required parameter apikey was null or undefined when calling stationsSearchGet.');
    }

    if (lat === null || lat === undefined) {
      throw new Error('Required parameter lat was null or undefined when calling stationsSearchGet.');
    }

    if (lng === null || lng === undefined) {
      throw new Error('Required parameter lng was null or undefined when calling stationsSearchGet.');
    }

    let queryParameters = new HttpParams({
      encoder: new CustomHttpUrlEncodingCodec(),
    });
    if (apikey !== undefined && apikey !== null) {
      queryParameters = queryParameters.set('apikey', <any>apikey);
    }
    if (lat !== undefined && lat !== null) {
      queryParameters = queryParameters.set('lat', <any>lat);
    }
    if (lng !== undefined && lng !== null) {
      queryParameters = queryParameters.set('lng', <any>lng);
    }
    if (rad !== undefined && rad !== null) {
      queryParameters = queryParameters.set('rad', <any>rad);
    }

    let headers = this.defaultHeaders;

    // to determine the Accept header
    let httpHeaderAccepts: string[] = ['application/json; charset=utf-8'];
    const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected != undefined) {
      headers = headers.set('Accept', httpHeaderAcceptSelected);
    }

    // to determine the Content-Type header

    return this.httpClient.request<Response200>('get', `${this.basePath}/stations/search`, {
      params: queryParameters,
      withCredentials: this.configuration.withCredentials,
      headers: headers,
      observe: observe,
      reportProgress: reportProgress,
    });
  }
}
